﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AttachedBehaviors.Framework
{
	public class EnumCheck
	{
		public EnumCheck()
		{
			this.TargetValue = new EnumTargetValue();
		}

		public object Value { get; private set; }

		public EnumTargetValue TargetValue { get; private set; }

		public bool IsMatch { get; private set; }

		public void Update(object value, string targetValue)
		{
			var valueChanged = value != this.Value;
			var targetValueChanged = targetValue != this.TargetValue.Text;

			if(valueChanged || targetValueChanged)
			{
				if(valueChanged)
				{
					this.Value = value;
				}

				this.TargetValue.Update(this.Value, targetValue);

				this.IsMatch = this.TargetValue.Matches(this.Value);
			}
		}
	}
}